#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <curses.h>
#include <unistd.h>
#include <sys/ioctl.h>


#include "klife.h"

void sigint_handler(int sig) {
  endwin();
  exit(0);
}


int main(int argc, char* argv[]) {
  int fd;
  char buf[(GRIDSIZE+1)*GRIDSIZE+1];
  char buf2[32];

  int len = sizeof(buf);

  // create a signalhandler so we can have ncurses
  // clean up the screen after a ctrl-c
  signal(SIGINT, sigint_handler);

  // initialise ncurses
  initscr();
  keypad(stdscr, TRUE);
  nonl();
  cbreak();
  noecho();

  // open our device
  fd = open("/dev/klife", O_RDWR);
  if (fd < 0) {
    perror("open /dev/klife");
    exit(1);
  }
  
  while(1) {
    int generation;

    len=sizeof(buf);
    len=read(fd, buf, len);

    // to be on the safe side, terminate with 0-byte
    buf[sizeof(buf)-1]=0; 

    mvaddstr(0,1, buf);

    // read the current generation via IOCTL 
    ioctl(fd, KLIFE_GET_GENERATION, &generation);
    snprintf(buf2, 32, "%i", generation);
    mvaddstr(0,0, buf2);

    refresh();

    sleep(1);
  }

  endwin();
  return 0;
}
